program ID_19001;
const
{  sin='19001.IN';}
  maxd=50;
  maxx=50;
  maxy=50;
  maxz=50;
type
  thole=
    record
      x,y,z,r:longint;
    end;
  tholes=array[1..maxd]of thole;
  tcube=array[0..maxx,0..maxy,0..maxz] of boolean;
  tfinal=array[-1..maxx,-1..maxy,-1..maxz] of longint;
var
  i,x,y,z,d:longint;
  hole:tholes;
  cube:tcube;
  threeD, biD, oneD:tfinal;
  bestsol:longint;

procedure read_Data;
begin
{  assign(input,sin);reset(input);}
  read(x,y,z,d);
  for i:=1 to d do
    with hole[i] do
      read(x,y,z,r);
{  close(input);}
end;

function dist(x1,y1,z1,x2,y2,z2:longint):real;
begin
  dist:=sqrt(sqr(x1-x2)+sqr(y1-y2)+sqr(z1-z2));
end;

procedure init_cube;
var
  xx,yy,zz,dd:longint;
  inside:boolean;
begin
  for xx:=0 to x do
    for yy:=0 to y do
      for zz:=0 to z do
        begin
          inside:=false;
          for dd:=1 to d do
            with hole[dd] do
              if dist(xx,yy,zz,x,y,z)<r then
                begin
                  inside:=true;
                  break;
                end;
          cube[xx,yy,zz]:=inside;
        end;
end;

function b2i(b:boolean):longint;
begin
  if b then b2i:=1
       else b2i:=0;
end;

procedure init_sums;
var
  xx,yy,zz:longint;
begin
  for xx:=0 to x do
    for yy:=0 to y do
      for zz:=0 to z do
        OneD[yy,zz,xx]:=OneD[yy,zz,xx-1]+b2i(cube[yy,zz,xx]);
  for xx:=0 to x do
    for yy:=0 to y do
      for zz:=0 to z do
        biD[zz,xx,yy]:=biD[zz,xx,yy-1]+OneD[yy,zz,xx];
  for xx:=0 to x do
    for yy:=0 to y do
      for zz:=0 to z do
        threeD[xx,yy,zz]:=threeD[xx,yy,zz-1]+biD[zz,xx,yy];
end;

function Exists(xx,yy,zz:longint):boolean;
var
  x0,y0,z0:longint;
  return:boolean;
begin
  return:=false;
  for x0:=0 to x-xx do
    for y0:=0 to y-yy do
      for z0:=0 to z-zz do
        if (ThreeD[x0+xx,y0+yy,z0+zz]-ThreeD[x0,y0,z0])=0 then
          begin
            Exists:=true;
            exit;
          end;
  Exists:=return;
end;

procedure BinSearch(start,stop:longint);
var
  xx,yy,zz,mid:longint;
  ok:boolean;
  bx,by,bz:longint;
begin
  if start>stop then
    exit;
  mid:=(start+stop)div 2;
  ok:=false;
  if Exists(mid,mid,mid) then ok:=true;
  if ok then
    if mid*mid*mid>bestsol then
      bestsol:=mid*mid*mid;
  if ok then
    BinSearch(mid+1,stop)
  else
    BinSearch(start,mid-1);
end;

function max(a,b:longint):longint;
begin
  if a>b then max:=a
         else max:=b;
end;

procedure find_solu;
begin
  if threeD[x,y,z]=0 then
    begin
      bestsol:=x*y*z;
      exit;
    end;
  bestsol:=0;
  BinSearch(0,max(x,max(y,z)));
end;

procedure write_sol;
begin
  writeln(bestsol);
end;

begin
  read_data;
  init_cube;
  init_sums;
  find_solu;
  write_sol;
end.
