program ID_19005;
const
  maxw=65536;
type
  tconfigs=array[1..2,0..maxw]of shortint;
  tcoord=
    record
      x,y:shortint;
    end;
  tcoords=array[1..2]of tcoord; {direction for the 2 players}
  tviceversa=array[1..2]of longint;
const
  coords:tcoords=
    ((x:0;y:-1),(x:+1;y:0));
  viceversa:tviceversa=(2,1);
var
  first:longint;
  config:word;
  configs:tconfigs;

procedure read_data;
var
  a:array[1..4*4]of longint;
  i:longint;
  c:char;
begin
  {assign(input,'19005.in');reset(input);}
  read(first);
  for i:=1 to 16 do
    begin
      repeat
        read(c);
      until (c='0') or (c='1');
      if c='1' then
        a[i]:=1
      else
        a[i]:=0;
    end;
{  close(input);}
  config:=0;
  for i:=1 to 16 do
    config:=config or (a[i] shl (i-1));
end;

function IsBit(w:word;bit:longint):boolean;
var
  bb:word;
begin
  bb:=1 shl (bit-1);
  IsBit:=(bb and w)<>0;
end;

procedure ReSetBit(var w:word;bit:longint);
var
  bb:word;
begin
  bb:=1 shl (bit-1);
  w:=w or bb;
  w:=w xor bb;
end;

procedure SetBit(var w:word;bit:longint);
var
  bb:word;
begin
  bb:=1 shl (bit-1);
  w:=w or bb;
end;

function OutSide(x,y:longint):boolean;
begin
  OutSide:=(x=0)or(y=0)or(x=5)or(y=5);
end;

function GetWinner(player:longint;config:word):longint;
var
  lastbit,newbit,lx,ly,nx,ny,x,y,bit,i,nmoves,return:longint;
  config2:word;
  player2:longint;
begin
  return:=configs[player,config];
  player2:=viceversa[player];
  configs[player,config]:=0;
  if return=-1 then
    begin
      nmoves:=0;
      for x:=1 to 4 do
        for y:=1 to 4 do
          begin
            bit:=(y-1)*4+x;
            if IsBit(config,bit) then
              begin
                lx:=x;
                ly:=y;
                repeat
                  nx:=lx+coords[player].x; {new x = last x + ...}
                  ny:=ly+coords[player].y;
                  config2:=config;
                  if not outside(nx,ny) then
                    begin
                      {i check this place to be clear}
                      newbit:=(ny-1)*4+nx;
                      lastbit:=(ly-1)*4+lx;
                      if IsBit(config,newbit) then
                        nx:=0
                      else
                        begin
                          {if it's clear out then we can make a bath}
                          ReSetBit(config2,lastbit);
                          SetBit(config2,newbit);
                          inc(nmoves);
                          if GetWinner(player2,config2)=0 then
                            begin
                              configs[player,config]:=1;
                              GetWinner:=1;
                              exit;
                            end;
                        end;
                    end;
                  lx:=nx;
                  ly:=ny;
                until outside(nx,ny);
              end;
          end;
    end;
  if nmoves=0 then
    configs[player,config]:=1;
  return:=configs[player,config];
  GetWinner:=return;
end;

procedure write_sol;
begin
  fillchar(configs,sizeof(configs),255);
  writeln(GetWinner(first,config));
end;

begin
  read_data;
  write_sol;
end.