program ID_19007;
const
  maxn=100;
type
  ta=array[1..2*maxn+3]of shortint;
  tm=array[0..maxn*2+1,0..maxn*2+1]of shortint;
  tb=array[0..maxn*2+1]of boolean;
var
  sins,souts,flow,n:longint;
  ins,outs:ta;
  m:tm;
  stack,father:ta;
  visited:tb;
  start,stop:longint;

procedure read_data;
var
  i:longint;
begin
{  assign(input,'19007.in');reset(input);}
  read(n);
  for i:=1 to n do
    begin
      read(ins[i],outs[i]);
      sins:=sins+ins[i];
      souts:=souts+outs[i];
    end;
{  close(input);}
end;

procedure init_data;
var
  i,j:longint;
begin
  for i:=1 to n do
    m[0,i]:=ins[i];
  for i:=1 to n do
    m[i+n,2*n+1]:=outs[i];
  for i:=1 to n do
    for j:=1 to n do
      if i<>j then
        m[i,j+n]:=1;
end;

procedure comp_data;
var
  i:longint;
begin
  flow:=0;
  if sins<>souts then
    exit;
  repeat
    fillchar(father,sizeof(father),0);
    fillchar(stack,sizeof(stack),0);
    start:=1;
    stop:=1;
    stack[1]:=0;
    fillchar(visited,sizeof(visited),0);
    visited[0]:=true;
    repeat
      for i:=0 to 2*n+1 do
        if not visited[i] then
          if m[stack[start],i]>0 then
            begin
              visited[i]:=true;
              father[i]:=stack[start];
              inc(stop);
              stack[stop]:=i;
            end;
      inc(start);
    until start>stop;
    if not visited[2*n+1] then
      exit;
    inc(flow);
    i:=2*n+1;
    repeat
      m[i,father[i]]:=m[i,father[i]]+1;
      m[father[i],i]:=m[father[i],i]-1;
      i:=father[i];
    until i=0;
  until false;
end;

procedure write_sol;
var
  i,j:longint;
begin
  if (sins<>souts) or (flow<>sins) then
    writeln(-1)
  else
    begin
      for i:=1 to n do
        for j:=1 to n do
          if i<>j then
            if m[i,j+n]=0 then
              writeln(j,' ',i);
    end;
end;

begin
  read_data;
  init_data;
  comp_data;
  write_sol;
end.