#include <stdio.h>
#include <stdlib.h>

int N, indeg[101], outdeg[101], insum, outsum, flow;
int graph[202][202], queue[202], up[202];

void read()
{
     int i;
     
//   freopen("in.txt", "r", stdin);
     scanf("%d", &N);
     for (i = 1; i <= N; i++)
         scanf("%d %d", &indeg[i], &outdeg[i]),
         graph[0][i] = indeg[i], graph[i + N][2 * N + 1] = outdeg[i],
         insum += indeg[i], outsum += outdeg[i];

     if (insum != outsum) { printf("-1\n"); exit(0); }
}

int augument()
{
     int head, tail, i, j;

     for (i = 0; i < 2 * N + 2; i++)
         queue[i] = 0, up[i] = -1;

     queue[0] = 0, up[0] = 0;
     for (head = tail = 0; head <= tail; head++)
     {
          i = queue[head];
          for (j = 0; j < 2 * N + 2; j++)
              if (graph[i][j] && up[j] == -1)
              {
                    up[j] = i;
                    queue[++tail] = j;
                    if (j == 2 * N + 1) { flow++; return 1; }
              }
     }

     return 0;
}

void solve()
{
     int i, j;

     for (i = 1; i <= N; i++)
     for (j = 1; j <= N; j++)
         if (i != j) graph[i][j + N] = 1;

     while (augument())
     for (i = 2 * N + 1; i; i = up[i])
         graph[up[i]][i]--,
         graph[i][up[i]]++;
}

void write()
{
     int i, j;
     
     if (flow < insum) { printf("-1\n"); return; }
     printf("%d\n", flow);
     for (i = 1; i <= N; i++)
     for (j = 1; j <= N; j++)
         if (graph[j + N][i]) printf("%d %d\n", j, i);
}

int main()
{
     read();
     solve();
     write();

     return 0;
}
